# Visualization
TKV3d
V3d

# V3d_PositionLight Class Reference

Base class for Positional, Spot and Directional Light classes
.

`#include <V3d_PositionLight.hxx>`

Inheritance diagram for V3d_PositionLight:

[legend]

## Public Member Functions

virtual Standard_EXPORT void | SetPosition (const V3d_Coordinate X, const V3d_Coordinate Y, const V3d_Coordinate Z)=0
| Defines the position of the light source. Should be redefined! .
Standard_EXPORT void | SetTarget (const V3d_Coordinate X, const V3d_Coordinate Y, const V3d_Coordinate Z)
| Defines the target of the light (the center of the sphere) .
Standard_EXPORT void | SetRadius (const Quantity_Parameter Radius)
| Define the radius. .
Standard_EXPORT void | OnHideFace (const Handle(V3d_View)&aView)
| Calculate the position of the light, on the hide face of the picking sphere. .
Standard_EXPORT void | OnSeeFace (const Handle(V3d_View)&aView)
| Calculate the position of the light, on the seen face of the picking sphere. .
Standard_EXPORT void | Tracking (const Handle(V3d_View)&aView, const V3d_TypeOfPickLight WathPick, const Standard_Integer Xpix, const Standard_Integer Ypix)
| Tracking the light position, or the light space, or the radius of the light space, that depends of initial picking "WhatPick" (see the pick method). If WhatPick is SPACELIGHT, then the parameters Xpix, Ypix are the coordinates of a translation vector. .
virtual Standard_EXPORT void | Display (const Handle(V3d_View)&aView, const V3d_TypeOfRepresentation Representation=V3d_SIMPLE)

Display the graphic structure of light source
in the choosen view. We have three type of representation
- SIMPLE : Only the light source is displayed.
- PARTIAL : The light source and the light space are
displayed.
- COMPLETE : The light source, the light space and the
radius of light space are displayed.
We can choose the "SAMELAST" as parameter of representation
In this case the graphic structure representation will be
the last displayed.
.

Standard_EXPORT void | Erase ()
| Erase the graphic structure of light source. .
virtual Standard_EXPORT V3d_TypeOfPickLight | Pick (const Handle(V3d_View)&aView, const Standard_Integer Xpix, const Standard_Integer Ypix) const
| Returns the type of pick element. "POSITIONLIGHT" : Representation of position light. "SPACELIGHT" : Representation of lighting space. "RADIUSLIGHT" : Representation of lighting space radius. "NOTHING" : Any component of light. Determinate which type of tracking apply. .
Standard_EXPORT Quantity_Parameter | Radius () const
| Returns the radius of the picking sphere. .
Standard_EXPORT Standard_Boolean | SeeOrHide (const Handle(V3d_View)&aView) const
| Returns the visibility status If True the source is visible. If False it's hidden. .
virtual Standard_EXPORT void | Position (V3d_Coordinate &X, V3d_Coordinate &Y, V3d_Coordinate &Z) const =0
| Returns the position of the light source. .
Standard_EXPORT void | Target (V3d_Coordinate &X, V3d_Coordinate &Y, V3d_Coordinate &Z) const
| Returns the position of the target of the light source. .
Standard_EXPORT const | Handle (Standard_Type)&DynamicType() const

## Protected Member Functions

Standard_EXPORT | V3d_PositionLight (const Handle(V3d_Viewer)&VM)

## Protected Attributes

Graphic3d_Vertex | MyTarget
V3d_TypeOfRepresentation | MyTypeOfRepresentation

## Private Member Functions

virtual Standard_EXPORT void | Symbol (const Handle(Graphic3d_Group)&gsymbol, const Handle(V3d_View)&aView) const =0
| Defines representation of the light source. .

## Constructor & Destructor Documentation

Standard_EXPORT V3d_PositionLight::V3d_PositionLight | ( | const Handle(V3d_Viewer)& | VM | ) | `[protected]`

## Member Function Documentation

virtual Standard_EXPORT void V3d_PositionLight::Display | ( | const Handle(V3d_View)& | aView,
|  | const V3d_TypeOfRepresentation | Representation = `V3d_SIMPLE`
| ) | `[virtual]`

| Reimplemented in V3d_DirectionalLight, V3d_PositionalLight, and V3d_SpotLight.

Standard_EXPORT void V3d_PositionLight::Erase | ( |  | ) |

Standard_EXPORT const V3d_PositionLight::Handle | ( | Standard_Type |  | ) | const

| Reimplemented from V3d_Light. Reimplemented in V3d_DirectionalLight, V3d_PositionalLight, and V3d_SpotLight.

Standard_EXPORT void V3d_PositionLight::OnHideFace | ( | const Handle(V3d_View)& | aView | ) |

Standard_EXPORT void V3d_PositionLight::OnSeeFace | ( | const Handle(V3d_View)& | aView | ) |

virtual Standard_EXPORT V3d_TypeOfPickLight V3d_PositionLight::Pick | ( | const Handle(V3d_View)& | aView,
|  | const Standard_Integer | Xpix,
|  | const Standard_Integer | Ypix
| ) | const`[virtual]`

virtual Standard_EXPORT void V3d_PositionLight::Position | ( | V3d_Coordinate & | X,
|  | V3d_Coordinate & | Y,
|  | V3d_Coordinate & | Z
| ) | const`[pure virtual]`

| Implemented in V3d_DirectionalLight, V3d_PositionalLight, and V3d_SpotLight.

Standard_EXPORT Quantity_Parameter V3d_PositionLight::Radius | ( |  | ) | const

Standard_EXPORT Standard_Boolean V3d_PositionLight::SeeOrHide | ( | const Handle(V3d_View)& | aView | ) | const

virtual Standard_EXPORT void V3d_PositionLight::SetPosition | ( | const V3d_Coordinate | X,
|  | const V3d_Coordinate | Y,
|  | const V3d_Coordinate | Z
| ) | `[pure virtual]`

| Implemented in V3d_DirectionalLight, V3d_PositionalLight, and V3d_SpotLight.

Standard_EXPORT void V3d_PositionLight::SetRadius | ( | const Quantity_Parameter | Radius | ) |

Standard_EXPORT void V3d_PositionLight::SetTarget | ( | const V3d_Coordinate | X,
|  | const V3d_Coordinate | Y,
|  | const V3d_Coordinate | Z
| ) |

virtual Standard_EXPORT void V3d_PositionLight::Symbol | ( | const Handle(Graphic3d_Group)& | gsymbol,
|  | const Handle(V3d_View)& | aView
| ) | const`[private, pure virtual]`

| Implemented in V3d_DirectionalLight, V3d_PositionalLight, and V3d_SpotLight.

Standard_EXPORT void V3d_PositionLight::Target | ( | V3d_Coordinate & | X,
|  | V3d_Coordinate & | Y,
|  | V3d_Coordinate & | Z
| ) | const

Standard_EXPORT void V3d_PositionLight::Tracking | ( | const Handle(V3d_View)& | aView,
|  | const V3d_TypeOfPickLight | WathPick,
|  | const Standard_Integer | Xpix,
|  | const Standard_Integer | Ypix
| ) |

## Field Documentation

Graphic3d_Vertex V3d_PositionLight::MyTarget `[protected]`

V3d_TypeOfRepresentation V3d_PositionLight::MyTypeOfRepresentation `[protected]`

The documentation for this class was generated from the following file:

- V3d_PositionLight.hxx